var flip = function() {
	var handlers = {};
	var defaultHandler;
	
	function listen(info) {
		var ws = new WebSocket("ws://" + document.location.host + "/ws", info);
		ws.onclose = ws.onerror = function(){
			setTimeout(function(){
				listen(info);
			}, 1000);
		};
		ws.onmessage = function(event) {
			var e = JSON.parse(event.data);
			var type = e.type;
			var data = e.data;
			if(defaultHandler)defaultHandler(type, data);
			var handler = handlers[type];
			if (!handler)
				return;
			handler(data);
		};
	}	
	
	return {
		on : function(type, handler) {
			handlers[type] = handler;
		},
		onAll : function(handler) {
			defaultHandler = handler;
		},
		listen : listen
	};
}();
